# CD Universe music scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    # Find List price
    i = string.find(source, ">List Price<")

    if (i != -1):
        listprice = searchForPlus(source, ">List Price<")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        aw.setListPrice(listprice)


    # Find Ranking
    i = string.find(source, ">All Time Sales Rank<")

    if (i != -1):
        usedinfo = searchForPlus(source, ">All Time Sales Rank<")
        usedinfo = searchForPlus(usedinfo, ">&nbsp;&nbsp;")
        i = string.find(usedinfo, "&")
        salesrank = stripText(usedinfo[0:i])
        aw.setSalesRank(salesrank)



    source = searchForPlus(source, "id=\"mastertable\"")


    # Find Image
    tag = "/CDUCoverArt/"
    i = string.find(source, tag)

    if i == -1 or i > 6000:
        tag = "/CDUCoverart/"
        i = string.find(source, tag)

    if i == -1 or i > 6000:
        tag = "/MuzeAudioArt/"
        i = string.find(source, tag)

    if i != -1 and i < 6000:
        image = stripText(source[i-100:])
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image-avail")

        if i == -1:
            aw.setImage1(image)

    i = string.find(source, ">Large Front<")

    if i != -1:
        images = stripText(source[i-150:])
        images = searchForPlus(images, "href=\"")
        i = string.find(images, "\"")
        images = "http://www.cduniverse.com" + stripText(images[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        images = http.getContents(images)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(images)
        t2.close()

        images = searchForPlus(images, "id=\"impc3\"")
        images = searchForPlus(images, "<img src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])
        aw.setLargeImage1(image)



    # Find Title
    i = string.find(source, "<h1 style")

    if i != -1:
        title = searchForPlus(source, "<h1 style")
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])

        if title.endswith(" CD") == 1:
            title = stripText(title[0: len(title)-3])
            aw.setFormat("CD")

        i = string.find(title, " - ")

        if i != -1:
            artist = stripText(title[0:i])
            aw.setArtist(artist)
            title = stripText(title[i+3:])

        aw.setTitle(title)


    # Find Artist
    i = string.find(source, "class='importantlink'")

    if i != -1:
        temp = searchForPlus(source, "class='importantlink'")

        if temp.startswith(" href") == 1:
            temp = searchForPlus(temp, "'>")
            i = string.find(temp, "<")
            artist = stripText(temp[0:i])

            i = string.find(artist, " Discography")

            if i != -1:
                artist = stripText(artist[0:i])

            if title.startswith(artist) == 1:
                aw.setTitle(stripText(title[len(artist):]))
        else:
            i = string.find(temp, "<")
            artist = stripText(temp[0:i])

        aw.setArtist(artist)


    # Find Price
    i = string.find(source, ">Sale Price:")

    if i == -1:
        i = string.find(source, ">Regular Price:")

    if i == -1:
        i = string.find(source, ">Our Price:")

    if i != -1:
        source = source[i:]
        source = searchFor(source, "$")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find keywords
    keywords = ""
    i = string.find(source, ">Category")

    if i != -1:
        temp = searchForPlus(source, ">Category")
        i = string.find(temp, "</tr>")
        temp = stripText(temp[0:i])

        while (searchFor(temp, " href") != None):
            temp = searchForPlus(temp, " href")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")

            if keywords == "":
                keywords = stripText(temp[0:i])
                category = keywords
            else:
                keywords = keywords + ", " + stripText(temp[0:i])

        aw.setKeywords(keywords)


    # Find Studio
    i = string.find(source, ">Label")

    if i != -1:
        label = searchForPlus(source, ">Label")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Copyright date
    i = string.find(source, ">Orig Year")

    if i != -1:
        copyDate = searchForPlus(source, ">Orig Year")
        copyDate = searchForPlus(copyDate, "<td>")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])
        aw.setCopyrightDate(copyDate)


    # Find Release date
    i = string.find(source, ">Release Date")

    if i != -1:
        date = searchForPlus(source, ">Release Date")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)


    # Find Sound
    i = string.find(source, ">Mono/Stereo")

    if i != -1:
        sound = searchForPlus(source, ">Mono/Stereo")
        sound = searchForPlus(sound, "<td>")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        aw.setSound(sound)


    # Find Comments
    tempcomment= ""
    i = string.find(source, "<!---- trimable --->")

    if i != -1:
        source = searchForPlus(source, "<!---- trimable --->")
        i = string.find(source, "<!---- trimable --->")
        tempcomment = source[0:i]
        aw.setProductInfo(tempcomment)


    # Find Tracks
    i = string.find(source, "\">Track Listing")

    if i != -1:
        source = searchForPlus(source, "\">Track Listing")
        i = string.find(source, ">1<")
        source = stripText(source[i-100:])
        i = string.find(source, "</table>")
        disks = stripText(source[0:i])

        if string.find(disks, " DISC 1:<") == -1:
            disks = " DISC 1:<" + disks

        diskCount = 0

        while (searchFor(disks, " DISC ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, " DISC ")
            i = string.find(disks, ":")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, " DISC")
            tracks = stripText(disks[0:i])
            trackNum = 0

            while (searchFor(tracks, "width=\"4\"") != None):
                tracks = searchForPlus(tracks, "width=\"4\"")
                tracks = searchForPlus(tracks, "\">")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                i = string.find(track, " - ")
                artist = ""

                if i != -1:
                    artist = stripText(track[i+3:])

                    if artist.startswith("(") == 1:
                        artist = ""
                    else:
                        track = stripText(track[0:i])

                time = ""
                i = string.find(tracks, "<td valign=\"top\" class=\"mp3gridfont\" style=\"padding-top:8px;\" align=\"right\">")

                if i != -1:
                    tracks = searchForPlus(tracks, "<td valign=\"top\" class=\"mp3gridfont\" style=\"padding-top:8px;\" align=\"right\">")
                    i = string.find(tracks, "<")
                    time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackNum, track, artist=artist, time=time)



    # Find Classical Works
    i = string.find(source, ">Detailed Work Information<")

    if i != -1:
        source = searchForPlus(source, ">Detailed Work Information<")
        source = searchForPlus(source, "<table")
        i = string.find(source, "</table>")
        works = stripText(source[0:i])

        diskCount = 1
        trackNum = 0

        while (searchFor(works, ".</b>") != None):
            works = searchForPlus(works, ".</b>")
            i = string.find(works, "<td COLSPAN=\"2\">")
            work = stripText(works[0:i])
            work = searchForPlus(work, "<span class=h3>")
            i = string.find(work, "<")
            track = stripText(work[0:i])

            time = ""
            i = string.find(work, "&nbsp;(")

            if i != -1:
                time = searchForPlus(work, "&nbsp;(")
                i = string.find(time, ")")
                time = stripText(time[0:i])

            composer = ""
            i = string.find(work, ">Composer")

            if i != -1:
                composer = searchForPlus(work, ">Composer")
                composer = searchForPlus(composer, "<a href")
                composer = searchForPlus(composer, "\">")
                i = string.find(composer, "<")
                composer = stripText(composer[0:i])

            soloist = ""
            i = string.find(work, ">Performer")

            if i != -1:
                soloist = searchForPlus(work, ">Performer")
                soloist = searchForPlus(soloist, "<a href")
                soloist = searchForPlus(soloist, "\">")
                i = string.find(soloist, "<")
                soloist = stripText(soloist[0:i])

            conductor = ""
            i = string.find(work, ">Conductor")

            if i != -1:
                conductor = searchForPlus(work, ">Conductor")
                conductor = searchForPlus(conductor, "<a href")
                conductor = searchForPlus(conductor, "\">")
                i = string.find(conductor, "<")
                conductor = stripText(conductor[0:i])

            trackNum = trackNum + 1

            aw.setTrack(diskCount, trackNum, track, composer=composer, soloist=soloist, conductor=conductor, time=time)


    # Find user rating
    i = string.find(source, ">Average Rating:")

    if i != -1:
        temp = searchForPlus(source, ">Average Rating:")
        temp = searchForPlus(temp, ">")
        i = string.find(temp, "out")
        rating = stripText(temp[0:i])
        aw.setMyRating(rating)





try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
