# audible.com audiobook scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")

    # Refresh page if necessary
    if string.find(source, "http-equiv=\"refresh\"") != -1:
        source = searchForPlus(source, "http-equiv=\"refresh\"")
        i = string.rfind(source, "URL=")
        source = stripText(source[i+4:])
        i = string.find(source, "\"")
        url = "http://www.audible.com" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Get detail page if necessary
    i = string.find(source, ">See product details<")

    if i != -1:
        source = stripText(source[i-100:])
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://www.audible.com" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t3 = open(rw.getLogsDir() + "trace3.html", "w")
        t3.write(source)
        t3.close()


    # Main extraction
    i = string.find(source, "<h1  class=\"bc-heading")

    if i == -1:
        return;


    # Find ASIN
    i = string.find(source, "asin=")

    if i != -1:
        asin = searchForPlus(source, "asin=")
        i = string.find(asin, "\"")
        asin = stripText(asin[0:i])
        i = string.find(asin, "&")

        if i != -1:
            asin = stripText(asin[0:i])

        rw.setASIN(asin)


    # Find Image
    i = string.find(source, "\"image\":")

    if i != -1:
        image = searchForPlus(source, "\"image\":")
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "<h1  class=\"bc-heading")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    rw.setTitle(title)


    # Find Author(s)
    authorList = []

    i = string.find(source, "href=\"/author/")

    if i != -1:
        source = searchFor(source, "href=\"/author/")
        i = string.find(source, "</li>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "href=") != None):
            authors = searchForPlus(authors, "href=")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author)


    # Find Narrator
    i = string.find(source, "Narrated by")

    if i != -1:
        source = searchForPlus(source, "Narrated by")
        i = string.find(source, "</li>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "href=") != None):
            authors = searchForPlus(authors, "href=")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author + " (Narrator)")

    rw.setAuthors(authorList)


    # Find Price
    i = string.find(source, ">Regular price:")

    if i != -1:
        value = source[i:]
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find List price
    i = string.find(source, "Retail Price:")

    if i == -1:
        i = string.find(source, "Regular Price:")

    if i != -1:
        listprice = stripText(source[i:])
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    # Find Format
    i = string.find(source, "class=\"adbl-prod-type\"")

    if i != -1:
        format = searchForPlus(source, "class=\"adbl-prod-type\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)
    else:
        rw.setFormat("Audiobook")


    # Find Publisher
    i = string.find(source, "Publisher:")

    if i != -1:
        publisher = searchForPlus(source, "Publisher:")
        publisher = searchForPlus(publisher, "href")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Dimensions (Length)
    i = string.find(source, "Length:")

    if i != -1:
        dimensions = searchForPlus(source, "Length:")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])
        rw.setDimensions(dimensions)


    # Find Release date
    i = string.find(source, "Release date:")

    if i != -1:
        date = searchForPlus(source, "Release date:")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find Comments
    comments = ""
    pubsum = ""
    reviews = ""
    i = string.find(source, ">Editorial Reviews<")

    if i != -1:
        comments = searchForPlus(source, ">Editorial Reviews<")
        comments = searchForPlus(comments, "class=\"bc-text")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</span")
        comments = stripText(comments[0:i])

    i = string.find(source, ">Publisher's Summary")

    if i != -1:
        pubsum = searchForPlus(source, ">Publisher's Summary")
        pubsum = searchForPlus(pubsum, "class=\"bc-text")
        pubsum = searchForPlus(pubsum, ">")
        i = string.find(pubsum, "</span")
        pubsum = stripText(pubsum[0:i])

    i = string.find(source, ">Critic Reviews")

    if i != -1:
        reviews = searchForPlus(source, ">Critic Reviews")
        reviews = searchForPlus(reviews, "class=\"bc-text")
        reviews = searchForPlus(reviews, ">")
        i = string.find(reviews, "</span")
        reviews = stripText(reviews[0:i])

    comments = appendComment(comments, pubsum)
    comments = appendComment(comments, reviews)
    rw.setProductInfo(comments)


    # Rating
    i = string.find(source, "class=\"bc-review-stars\"")

    if i != -1:
        rating = searchForPlus(source, "class=\"bc-review-stars\"")
        rating = searchForPlus(rating, "label=\"rating:")
        i = string.find(rating, "\"")
        rating = stripText(rating[0:i])
        rw.setMyRating(rating)





try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
