# OZON.RU  book scraper
#
# Copyright  1999-2014 Readerware Corporation.  All Rights Reserved.

import  os
import  string
import  time

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("Russia")


    i = string.find(source, "class=\"bAlsoSearch\"")

    if i != -1:
        source = searchForPlus(source, "class=\"bAlsoSearch\"")
        source = searchForPlus(source, "itemprop=\"itemListElement\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://www.ozon.ru" + stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url, "windows-1251")
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image
    image = ""
    i = string.find(source, "class=\"eMicroGallery_fullImage\"")

    if i != -1:
        images = searchForPlus(source, "class=\"eMicroGallery_fullImage\"")
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        if image.startswith("//") == 1:
            image = "http:" + image

        rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "<h1 class=\"bItemName\"")
    source = searchForPlus(source, "\">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    rw.setTitle(title)


    # Find Authors
    authorList = []
    tag = "itemprop=\"author\""

    i = string.find(source, tag)

    if i != -1:
        source = searchFor(source, tag)
        i = string.find(source, "\n")
        authors = stripText(source[0:i])

        if string.find(authors, "<a href=") == -1:
            author = searchForPlus(authors, ":")

            i = string.find(author, "<")

            if i != -1:
                author = stripText(author[0:i])
                
            if author != "":
                authorList.append(author)

        else:
            while (searchFor(authors, "<a href=") != None):
                authors = searchForPlus(authors, "<a href=")
                authors = searchForPlus(authors, "\">")
                i = string.find(authors, "<")
                author = stripText(authors[0:i])
                authors = searchForPlus(authors, "</a>")
                authors = stripText(authors)
                
                if author != "":
                    authorList.append(author)

    rw.setAuthors(authorList)


    # Find Language
    i = string.find(source, "itemprop=\"inLanguage\"")

    if i != -1:
        language = searchForPlus(source, "itemprop=\"inLanguage\"")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        rw.setLanguage(language[0:i])


    # Find ISBN
    i = string.find(source, "itemprop=\"isbn\"")

    if i != -1:
        isbn = searchForPlus(source, "itemprop=\"isbn\"")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        i = string.find(isbn, ",")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find Format
    i = string.find(source, "itemprop=\"bookFormat\"")

    if i != -1:
        format = searchForPlus(source, "itemprop=\"bookFormat\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Pages
    i = string.find(source, "itemprop=\"numberOfPages\"")

    if i != -1:
        pages = searchForPlus(source, "itemprop=\"numberOfPages\"")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Publisher
    i = string.find(source, "itemprop=\"publisher\"")

    if i != -1:
        publisher = searchForPlus(source, "itemprop=\"publisher\"")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find value
    i = string.find(source, "itemprop=\"price\"")

    if i != -1:
        value = searchForPlus(source, "itemprop=\"price\"")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, " ")

        if i != -1:
            currency = stripText(value[i:])
            rw.setCurrencySymbol(currency)
            value = stripText(value[0:i])

        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Comments
    comments = ""
    tag = "class=\"eProductDescriptionText_title\""

    if string.find(source, tag) != -1:
        comment = searchForPlus(source, tag)
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    tag = "class=\"eProductDescriptionText_text\""

    if string.find(source, tag) != -1:
        comment = searchForPlus(source, tag)
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    rw.setProductInfo(comments)


    # Find Category
    tag = "Similar Items by Category<"

    if string.find(source, tag) == -1:
        # Amazon UK
        tag = ">Look for similar items by category<"

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        i = string.find(cats, "</li>")

        if i != -1:
            cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Books":
                continue

            if cat == "Kindle Store":
                continue

            if cat == "Kindle eBooks":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
