# LaserDisc Database video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw
import  vwimdbex

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("$")


    # Check for LDDB not found page. They are listing some US UPCs with a leading 0
    # retry if not found.
    i = string.find(source, "Database found nothing for &nbsp;UPC")

    if i != -1:
        upc = searchForPlus(source, "Database found nothing for &nbsp;UPC")
        upc = searchForPlus(upc, "<b>")
        i = string.find(upc, "*")
        upc = stripText(upc[0:i])
        print "UPC=",upc

        if len(upc) == 12:
            upc = "0" + upc
            url = "http://www.lddb.com/search.php?UPC=" + upc
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            source = http.getContents(url)
            t2 = open(vw.getLogsDir() + "trace2.html", "w")
            t2.write(source)
            t2.close()


    # Check for LDDB search results page and get first detail listing
    i = string.find(source, "<title>LaserDisc Database - Search")

    if i != -1:
        source = searchForPlus(source, "<title>LaserDisc Database - Search")
        source = searchFor(source, "http://www.lddb.com/laserdisc/")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Check for IMDb link and extract
    i = string.find(source, "http://akas.imdb.com/title/")

    if i != -1:
        lddbsource = source
        source = searchFor(source, "http://akas.imdb.com/title/")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace3.html", "w")
        t2.write(source)
        t2.close()

        print "IMDB link returned"

        try:
            vwimdbex.extract(source)
            vw.setRegion("")
            vw.setAspectRatio("Standard")
        except:
            print "IMDb extraction failed"

        imageref=url
        source = lddbsource




    # Find Image
    i = string.find(source, "<!-- End of Left Table -->")

    if i != -1:
        source = searchForPlus(source, "<!-- End of Left Table -->")
        i = string.find(source, "href=\"http://www.lddb.com/cover/ld/")

        if i != -1 and i < 400:
            image = searchForPlus(source, "href=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, " [")

            if i != -1:
                image = ""

            i = string.find(image, "PNA.gif")

            if i != -1:
                image = ""

            if image != "":
                vw.setLargeImage1(image)

        i = string.find(source, "><img ")

        if i != -1 and i < 400:
            image = searchForPlus(source, "><img ")
            image = searchForPlus(image, "src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, " [")

            if i != -1:
                image = ""

            i = string.find(image, "PNA.gif")

            if i != -1:
                image = ""

            if image != "":
                vw.setImage1(image)


    # Find Title
    i = string.find(source, "width=\"20\"")

    if i != -1:
        source = searchForPlus(source, "width=\"20\"")
        source = searchForPlus(source, "class=\"lddb\">")
        i = string.find(source, "</h3>")
        title = stripText(source[0:i])
        title = string.replace(title, "<i>", "")
        title = string.replace(title, "</i>", "")

        if title[0:3] == "<a ":
            title = searchForPlus(title, "\">")
            

        i = string.rfind(title, " [")

        if i != -1:
            title = stripText(title[0:i])

        vw.setTitle(title)


    # Find Copyright date
    i = string.find(title, " (")

    if i != -1:
        copyDate = stripText(title[i+2:])
        i = string.find(copyDate, ")")
        copyDate = stripText(copyDate[0:i])
        i = string.find(title, " (")
        title = stripText(title[0:i])
        vw.setCopyrightDate(copyDate)
        vw.setTitle(title)


    # Find Place
    i = string.find(source, ">Country")

    if i != -1:
        source = searchForPlus(source, ">Country")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        place = stripText(source[0:i])
        vw.setPlace(place)


    # Find Release date
    date = ""
    i = string.find(source, ">Street date")

    if i != -1:
        source = searchForPlus(source, ">Street date")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        date = stripText(source[0:i])
        date = string.replace(date, "???", "")
        vw.setReleaseDate(date)


    # Find Studio
    i = string.find(source, ">Publisher")

    if i != -1:
        source = searchForPlus(source, ">Publisher")
        source = searchForPlus(source, "class=\"data\">")

        if source.startswith("&nbsp;<a href") == 1:
            source = searchForPlus(source, "\">")
            
        i = string.find(source, "<")
        studio = stripText(source[0:i])
        vw.setStudio(studio)


    # Find Price
    i = string.find(source, ">Price")

    if i != -1:
        source = searchForPlus(source, ">Price")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        vw.setItemValue(value[0:i])

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find UPC
    i = string.find(source, ">UPC")

    if i != -1:
        source = searchForPlus(source, ">UPC")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        upc = stripText(source[0:i])
        upc = string.replace(upc, "???", "")
        upc = string.replace(upc, "(none)", "")
        upc = stripText(upc)
        vw.setUPC(upc)


    # Find Category
    i = string.find(source, ">Category")

    if i != -1:
        source = searchForPlus(source, ">Category")
        source = searchForPlus(source, "class=\"data\">")

        if source.startswith("&nbsp;<a href") == 1:
            source = searchForPlus(source, "\">")
            
        i = string.find(source, "<")
        category = stripText(source[0:i])
        vw.setCategory1(category)


    # Find ISBN
    i = string.find(source, ">I-S-B-N")

    if i != -1:
        source = searchForPlus(source, ">I-S-B-N")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        isbn = stripText(source[0:i])
        vw.setISBN(isbn)


    # Find Color
    i = string.find(source, ">Color")

    if i != -1:
        source = searchForPlus(source, ">Color")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        color = stripText(source[0:i])
        vw.setColor(color)


    # Find Running time
    i = string.find(source, ">Length")

    if i != -1:
        source = searchForPlus(source, ">Length")
        source = searchForPlus(source, "class=\"data\">")
        i = string.find(source, "<")
        running = stripText(source[0:i])
        running = string.replace(running, "???", "")
        running = string.replace(running, "&nbsp;", "")
        vw.setRunningTime(running)


    # Find Aspect Ratio
    wide = "Standard"
    i = string.find(source, "Letterboxed")

    if i != -1:
        wide = "Widescreen"
    else:
        i = string.find(source, "logo/wide.gif")

        if i != -1:
            wide = "Widescreen"

    i = string.find(source, ">Ratio")

    if i != -1:
        ratio = searchForPlus(source, ">Ratio")
        ratio = searchForPlus(ratio, "class=\"data\"")
        ratio = searchForPlus(ratio, ">")
        i = string.find(ratio, "<")
        ratio = stripText(ratio[0:i])
        wide = wide + ratio

    vw.setAspectRatio(wide)


    # Find captioning
    i = string.find(source, "logo/cc.gif")

    if i != -1:
        vw.setClosedCaptioned("true")


    # Find Format
    format = "LaserDisc"
    i = string.find(source, "mode/clv.")

    if i != -1:
        format = "LaserDisc [CLV]"

    i = string.find(source, "mode/cav.")

    if i != -1:
        format = "LaserDisc [CAV]"

    i = string.find(source, "mode/clv_cav.")

    if i != -1:
        format = "LaserDisc [CAV]"

    vw.setFormat(format)


    # Find Sound
    sound = "Stereo"
    i = string.find(source, "/logo/dolby/surround")

    if i != -1:
        sound = "Dolby Surround"

    i = string.find(source, "/images/sound/20.")

    if i != -1:
        sound = "Stereo"

    i = string.find(source, "/images/sound/10.")

    if i != -1:
        sound = "Mono"

    vw.setSound(sound)





try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
